# Managed API for Jira On-Premises
Managed API for Jira On-Premises is an API Client for Jira On-Premises by [Adaptavist](https://www.adaptavist.com/) primarily designed for the use in [ScriptRunner Connect](https://scriptrunnerconnect.com). You can read more about Managed APIs [here](https://docs.adaptavist.com/src/managed-apis).

This is a runtime agnostic version of the Managed API (with `core` suffix) that makes it easy to port it to any runtime you may want to use this Managed API on.

# Platform specific ports
- [ScriptRunner Connect](https://www.npmjs.com/package/@managed-api/jira-on-prem-v8-sr-connect)

# Supported API calls
- [fetch](https://docs.adaptavist.com/src/managed-apis/managed-api-abstractions)
- Application
    - Role
        - [getRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#applicationrole-get)
        - [getRoles](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#applicationrole-getAll)
        - [updateRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#applicationrole-put) 
- Dashboard
    - [getDashboard](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#dashboard-getDashboard)
    - [getDashboards](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#dashboard-list)
- Filter 
    - [createFilter](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-createFilter)
    - [deleteFilter](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-deleteFilter) 
    - [editFilter](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-editFilter) 
    - [getFilter](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getFilter)
    - [getMyFavouriteFilters](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getFavouriteFilters) 
    - Column 
        - [getDefaultColumns](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-defaultColumns)
        - [resetColumns](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-resetColumns) 
        - [setDefaultColumns](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-setColumns)
    - Share
        - [getShareScope](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getDefaultShareScope)
        - [setShareScope](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-setDefaultShareScope)
        - Permission
            - [addSharePermission](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-addSharePermission)
            - [deleteSharePermission](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getSharePermission)
            - [getSharePermission](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getSharePermission)
            - [getSharePermissions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#filter-getSharePermissions)
- Group
    - [createGroup](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#group-createGroup)
    - [removeGroup](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#group-removeGroup)
    - User
        - [addUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#group-addUserToGroup)
        - [getUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#group-getUsersFromGroup)
        - [removeUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#group-removeUserFromGroup)
- Instance
    - [getApplicationProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#application-properties-getProperty)
    - [getAdvancedSettings](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#application-properties-getAdvancedSettings)
    - [getConfiguration](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#configuration-getConfiguration)
    - [getInfo](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#serverInfo-getServerInfo)
    - [setApplicationProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#application-properties-setPropertyViaRestfulTable)
- Issue
    - [assignIssue](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-assign)
    - [createIssue](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-createIssue)
    - [deleteIssue](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-deleteIssue)
    - [editIssue](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-editIssue)
    - [getIssue](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getIssue)
    - [sendNotification](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-notify)
    - Attachment
        - [addAttachment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue/{issueIdOrKey}/attachments-addAttachment)
        - [getAttachment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#attachment-getAttachment)
        - [removeAttachment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#attachment-removeAttachment)
    - Comment
        - [addComment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-addComment)
        - [deleteComment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-deleteComment)
        - [getComments](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getComments)
        - [getComment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getComment)
        - [updateComment](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-updateComment)
        - Property
            - [deleteProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#comment/{commentId}/properties-deleteProperty)
            - [getProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#comment/{commentId}/properties-setProperty)
            - [getPropertyKeys](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#comment/{commentId}/properties-getPropertiesKeys)
            - [setProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#comment/{commentId}/properties-setProperty)
    - Field
        - [getFields](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#field-getFields)
        - Custom
            - [getFields](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#customFields-getCustomFields)
            - Option
                - [getOption](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#customFieldOption-getCustomFieldOption)
    - Link
        - [createLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLink-linkIssues)
        - [deleteLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLink-deleteIssueLink)
        - [getLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLink-getIssueLink)
        - Remote
            - [createOrUpdateLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-createOrUpdateRemoteIssueLink)
            - [deleteLinkByGlobalId](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-deleteRemoteIssueLinkByGlobalId)
            - [getLinks](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getRemoteIssueLinks)
            - [getLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getRemoteIssueLinkById)
            - [updateLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-updateRemoteIssueLink)
            - [deleteLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-deleteRemoteIssueLinkById)
        - Type
            - [createType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLinkType-createIssueLinkType)
            - [deleteType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLinkType-deleteIssueLinkType)
            - [getTypes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLinkType-getIssueLinkTypes)
            - [getType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLinkType-getIssueLinkType)
            - [updateType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issueLinkType-updateIssueLinkType)
    - Metadata
        - [getEditMetadata](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getEditIssueMeta)
        - [getCreateMetadata](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getCreateIssueMeta)
    - Notification
        - Scheme
            - [getSchemes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#notificationscheme-getNotificationSchemes)
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#notificationscheme-getNotificationScheme)
    - Priority
        - [getPriorities](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#priority-getPriorities)
        - [getPriority](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#priority-getPriority)
        - Scheme
            - [createScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#priorityschemes-createPriorityScheme)
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#priorityschemes-getPriorityScheme)
            - [getSchemes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#priorityschemes-getPrioritySchemes)
            - [deleteScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#priorityschemes-deletePriorityScheme)
            - [updateScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#priorityschemes-updatePriorityScheme)
    - Property
        - [getProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issue/{issueIdOrKey}/properties-getProperty)
        - [getPropertyKeys](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issue/{issueIdOrKey}/properties-getPropertiesKeys)
        - [deleteProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issue/{issueIdOrKey}/properties-deleteProperty)
        - [setProperty](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issue/{issueIdOrKey}/properties-setProperty)
    - Resolution
        - [getResolutions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#resolution-getResolutions)
        - [getResolution](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#resolution-getResolution)
    - Search
        - [searchByJql](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#resolution-getResolution)
    - Security
        - Scheme
            - [getSchemes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuesecurityschemes-getIssueSecuritySchemes)
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuesecurityschemes-getIssueSecurityScheme)
    - Subtask
        - [canMoveSubTask](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue/{issueIdOrKey}/subtask-canMoveSubTask)
        - [getSubTasks](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue/{issueIdOrKey}/subtask-getSubTasks)
        - [moveSubTasks](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue/{issueIdOrKey}/subtask-moveSubTasks)
    - Transition
        - [getTransitions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue/{issueIdOrKey}/subtask-moveSubTasks)
        - [performTransition](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-doTransition)
    - Type
        - [createType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-createIssueType)
        - [deleteType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-deleteIssueType)
        - [getAlternativeTypes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-getAlternativeIssueTypes)
        - [getTypes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-getIssueAllTypes)
        - [getType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-getIssueType)
        - [updateType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issuetype-updateIssueType)
        - Scheme
            - [createScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-createIssueTypeScheme)
            - [deleteScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-deleteIssueTypeScheme)
            - [getSchemes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-getAllIssueTypeSchemes)
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-getIssueTypeScheme)
            - [updateScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-updateIssueTypeScheme)
            - Project
                - [addAssociations](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-doTransition)
                - [getAssociations](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-getAssociatedProjects)
                - [setAssociations](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-setProjectAssociationsForScheme)
                - [removeAssociations](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-removeAllProjectAssociations)
                - [removeAssociation](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#issuetypescheme-removeProjectAssociation)
    - Vote
        - [addVote](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-addVote)
        - [getVotes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getVotes)
        - [removeVote](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-removeVote)
    - Watcher
        - [addWatcher](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-addWatcher)
        - [getWatchers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getIssueWatchers)
        - [removeWatcher](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-removeWatcher)
    - Worklog
        - [addWorklog](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-addWorklog)
        - [deleteWorklog](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-deleteWorklog)
        - [getWorklogs](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getIssueWorklog)
        - [getWorklog](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-getWorklog)
        - [getDeletedWorklogIds](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#worklog-getIdsOfWorklogsDeletedSince)
        - [getWorklogsForIds](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#worklog-getWorklogsForIds)
        - [getUpdatedWorklogIds](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#worklog-getIdsOfWorklogsModifiedSince)
        - [updateWorklog](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#issue-updateWorklog)
- Myself
    - [getPreference](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#mypreferences-getPreference)
    - [getCurrentUser](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#myself-getUser)
    - [removePreference](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#mypreferences-removePreference)
    - [setPreference](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#mypreferences-setPreference)
- Permission
    - [getPermissions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#-getAllPermissions)
    - [getMyPermissions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#-getPermissions)
    - Scheme
        - [createScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getPermissionSchemes)
        - [deleteScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-deletePermissionScheme)
        - [getSchemes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getPermissionSchemes)
        - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getPermissionScheme)
        - [updateScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-updatePermissionScheme)
        - Attribute
            - [getAttribute](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getSchemeAttribute)
        - Grant
            - [createGrant](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-createPermissionGrant)
            - [deleteGrant](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-deletePermissionSchemeEntity)
            - [getGrant](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getPermissionSchemeGrant)
            - [getGrants](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#permissionscheme-getPermissionSchemeGrants)
- Project
    - [archiveProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-archiveProject)
    - [createProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-createProject)
    - [deleteProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-deleteProject)
    - [getComponents](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProjectComponents)
    - [getProjects](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getAllProjects)
    - [getProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProject)
    - [getStatuses](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getAllStatuses)
    - [getVersionsPaginated](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProjectVersionsPaginated)
    - [getVersions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProjectVersions)
    - [restoreProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProjectComponents)
    - [updateProject](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-getProject)
    - [updateProjectType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project-updateProjectType)
    - Component
        - [createComponent](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#component-createComponent)
        - [deleteComponent](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#component-delete)
        - [getRelatedIssueCount](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#component-getComponentRelatedIssues)
        - [getComponent](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#component-getComponent)
        - [updateComponent](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#component-updateComponent)
    - Issue
        - Security
            - Scheme
                - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#project/{projectKeyOrId}/issuesecuritylevelscheme-getIssueSecurityScheme)
    - Notification
        - Scheme
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#project/{projectKeyOrId}/notificationscheme-getNotificationScheme)
    - Permission
        - Scheme
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#project/{projectKeyOrId}/permissionscheme-getAssignedPermissionScheme)
    - Priority
        - Scheme
            - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#project/{projectKeyOrId}/priorityscheme-getAssignedPriorityScheme)
    - Role
        - [getRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/{projectIdOrKey}/role-getProjectRole)
        - [getRoles](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/{projectIdOrKey}/role-getProjectRoles)
        - Actor
            - [addUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/{projectIdOrKey}/role-addActorUsers)
            - [deleteActor](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/{projectIdOrKey}/role-deleteActor)
            - [setActors](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/{projectIdOrKey}/role-setActors)
    - Security
        - [getLevels](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#project/{projectKeyOrId}/securitylevel-getSecurityLevelsForProject)
    - Type
        - [getAccessibleType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/type-getAccessibleProjectTypeByKey)
        - [getTypes](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/type-getAllProjectTypes)
        - [getType](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#project/type-getProjectTypeByKey)
    - Validation
        - [validateProjectKey](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#projectvalidate-getProject)
    - Version
        - [createVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-createVersion)
        - [deleteVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-delete)
        - [getVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-getVersion)
        - [moveVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-moveVersion)
        - [mergeVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-merge)
        - [removeAndReplaceVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-delete)
        - [updateVersion](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-updateVersion)
        - Count
            - [getVersionRelatedIssueCount](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-getVersionRelatedIssues)
            - [getVersionUnresolvedIssueCount](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#version-getVersionUnresolvedIssues)
        - Remote
            - [createOrUpdateLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-createOrUpdateRemoteVersionLink)
            - [createOrUpdateLinkById](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-createOrUpdateRemoteVersionLink)
            - [deleteLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-deleteRemoteVersionLink)
            - [deleteLinksById](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-deleteRemoteVersionLinksByVersionId)
            - [getLink](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-getRemoteVersionLink)
            - [getLinks](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-getRemoteVersionLinks)
            - [getLinksById](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#version-getRemoteVersionLinksByVersionId)
- Role
    - Project
        - [createRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-createProjectRole)
        - [deleteRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-deleteProjectRole)
        - [getRole](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#role-getProjectRolesById)
        - [getRoles](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#role-getProjectRoles)
        - [updateRolePartially](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-partialUpdateProjectRole)
        - [updateRoleFully](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#role-getProjectRolesById)
        - Actor
            - [addActors](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-addProjectRoleActorsToRole)
            - [deleteActors](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-deleteProjectRoleActorsFromRole)
            - [getActors](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#role-getProjectRoleActorsForRole)
- Screen
    - [getFieldsToAdd](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-getFieldsToAdd)
    - [getScreens](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-getAllScreens)
    - Field
        - [addField](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-addField)
        - [addToDefaultScreen](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-addFieldToDefaultScreen)
        - [getFields](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-getAllFields)
        - [moveField](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-moveField)
        - [removeField](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-removeField)
    - Tab
        - [addTab](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-addTab)
        - [deleteTab](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-deleteTab)
        - [getTabs](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-getAllTabs)
        - [moveTab](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-moveTab)
        - [renameTab](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#screens-renameTab)
- User
    - [addUserToApplication](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-addUserToApplication)
    - [changeUserPassword](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-changeUserPassword) 
    - [createUser](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-createUser)
    - [getUser](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-getUser)
    - [updateUser](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-updateUser)
    - [removeUser](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-removeUser)
    - [removeUserFromApplication](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-removeUserFromApplication)
    - Search
        - [findAssignableUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-findAssignableUsers)
        - [findUsers](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-findUsers)
        - [findUsersWithAllPermissions](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-findUsersWithAllPermissions)
        - [findUsersWithBrowsePermission](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#user-findUsersWithBrowsePermission)
- Workflow
    - [getWorkflows](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#workflow-getAllWorkflows)
    - Scheme
        - [createScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#workflowscheme-createScheme)
        - [deleteScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#workflowscheme-getById)
        - [getScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#workflowscheme-getById)
        - [updateScheme](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.2/#workflowscheme-update)
    - Status
        - [getStatus](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#status-getStatus)
        - [getStatuses](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#status-getStatuses)
        - Category
            - [getCategories](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#statuscategory-getStatusCategories)
            - [getCategory](https://docs.atlassian.com/software/jira/docs/api/REST/8.20.0/#statuscategory-getStatusCategories)

# Porting to other runtimes
While the primary reason for creating Managed APIs was to use them in [ScriptRunner Connect](https://scriptrunnerconnect.com) runtime, then you can easily port them to any runtime of your choosing.

You can do so by extending the `*Core` Managed API class where you'll be asked to provide implementation for `getPlatformImplementation` function. In this implementation you have yo specify how to perform buffer encoding/decoding operations and how to perform HTTP calls:
```typescript
{
    buffer: {
        encode(input: string): ArrayBuffer;
        decode(input: ArrayBuffer): string;
    },
    performHttpCall(request: Request): Promise<Response>
}
```

Here is an example how to create a [Node](https://nodejs.org/en/) port of the Managed API:
```typescript
import { JiraOnPremApiCore } from "@managed-api/jira-on-prem-v8-core";
import { PlatformImplementation, Request, Response, Headers } from "@managed-api/commons-core";
import fetch from "node-fetch";

export class JiraOnPremApi extends JiraOnPremApiCore {
    constructor(private baseUrl: string, private authToken: string) {
        super();
    }

    protected getPlatformImplementation(): PlatformImplementation {
        return {
            buffer: {
                encode: (input) => Buffer.from(input, 'utf-8'),
                decode: (input) => Buffer.from(input).toString('utf-8')
            },
            performHttpCall: (request) => this.performHttpCall(request)
        };
    }

    private async performHttpCall(request: Request): Promise<Response> {
        const requestUrl = `${this.baseUrl}${request.url}`; // Substitute base URL
        request.headers.set('Authorization', `Basic ${this.authToken}`); // Substitute auth token
        const response = await fetch(requestUrl, {
            method: request.method,
            headers: request.headers as any,
            body: request.method.toLowerCase() !== 'get' && request.method.toLowerCase() !== 'head' ? Buffer.from((await request.arrayBuffer()) ?? new ArrayBuffer(0)) : undefined
        });

        const apiHeaders = new Headers();
        response.headers.forEach((value, key) => apiHeaders.append(key, value));

        const body = await response.arrayBuffer();

        return super.buildResponse(response.url, response.status, response.statusText, apiHeaders, body);
    }
}
```

Please note that the authentication handling details may not be accurate and serve as an example. If you wish yo use these Managed APIs without having to concern yourself how to deal with and secure authentication details when working with APIs, then feel free to evaluate [ScriptRunner Connect](https://scriptrunnerconnect.com) platform.

# Contact
At this time Managed APIs are unlicensed and close sourced, but feel free to drop an email to [eknoll@adaptavist.com](mailto://eknoll@adaptavist.com) for ideas, suggestions and improvements.

# Changelog

* 2.1.0
    - Fixed class name.

* 2.0.0
    - `Breaking change:` URL and query string parameters are now URL encoded, meaning if you encoded them explicitly before you have to remove your own encoding, otherwise they will get double encoded.
* 1.2.0
    - Added support for custom fields in `Issue.editIssue`.
    - Added `null` type to `duedate` field.

Copyright Adaptavist 2022 (c) All rights reserved