/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { Filter } from '../definitions/filter';
import { ErrorStrategyOption } from '../errorStrategy';
export interface CreateFilterRequest extends HeadersOption, ErrorStrategyOption {
    expand?: string;
    body: Filter;
}
export interface CreateFilterResponseOK extends Filter {
}
export declare type CreateFilterResponseError = undefined;
export interface GetFilterRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    /**
     * the parameters to expand
     */
    expand?: string[];
}
export interface GetFilterResponseOK extends Filter {
}
export declare type GetFilterResponseError = undefined;
export interface EditFilterRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    expand?: string;
    body: Filter;
}
export interface EditFilterResponseOK extends Filter {
}
export declare type EditFilterResponseError = undefined;
export interface DeleteFilterRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export declare type DeleteFilterResponseOK = undefined;
export declare type DeleteFilterResponseError = undefined;
export interface GetMyFavouriteFiltersRequest extends HeadersOption, ErrorStrategyOption {
    expand?: string;
}
export interface GetMyFavouriteFiltersResponseOK extends Array<Filter> {
}
export declare type GetMyFavouriteFiltersResponseError = undefined;
//# sourceMappingURL=filter.d.ts.map