/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { FilterPermission } from '../../../definitions/filter';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface GetFilterSharePermissionsRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export interface GetFilterSharePermissionsResponseOK extends Array<FilterPermission> {
}
export declare type GetFilterSharePermissionsResponseError = undefined;
export interface AddFilterSharePermissionRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: {
        projectId?: string;
        projectRoleId?: string;
        userKey?: string;
        type?: string;
        groupname?: string;
        view: boolean;
        edit: boolean;
    };
}
export interface AddFilterSharePermissionResponseOK extends Array<FilterPermission> {
}
export declare type AddFilterSharePermissionResponseError = undefined;
export interface GetFilterSharePermissionRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    permissionId: string | number;
}
export interface GetFilterSharePermissionResponseOK extends FilterPermission {
}
export declare type GetFilterSharePermissionResponseError = undefined;
export interface DeleteFilterSharePermissionRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    permissionId: string | number;
}
export declare type DeleteFilterSharePermissionResponseOK = undefined;
export declare type DeleteFilterSharePermissionResponseError = undefined;
//# sourceMappingURL=permission.d.ts.map