/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { GroupResponse } from '../definitions/group';
import { ErrorStrategyOption } from '../errorStrategy';
export interface CreateGroupRequest extends HeadersOption, ErrorStrategyOption {
    body: {
        /**
         * The name of the group to create.
         */
        name: string;
    };
}
export interface CreateGroupResponseOK extends GroupResponse {
}
export declare type CreateGroupResponseError = undefined;
export interface RemoveGroupRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The name of the group to delete.
     */
    groupname: string;
    /**
     * If you delete a group and content is restricted to that group, the content will be hidden from all users. To prevent this, use this parameter to specify a different group to transfer the restrictions (comments and worklogs only) to.
     */
    swapGroup?: string;
}
export declare type RemoveGroupResponseOK = undefined;
export declare type RemoveGroupResponseError = undefined;
//# sourceMappingURL=group.d.ts.map