/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { GetUsersResponse, GroupResponse } from '../../definitions/group';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetUsersFromGroupRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * a name of the group for which members will be returned.
     */
    groupname: string;
    /**
     * inactive users will be included in the response if set to true.
     */
    includeInactiveUsers?: boolean;
    /**
     * the index of the first user in group to return (0 based).
     */
    startAt?: number;
    /**
     * the maximum number of users to return (max 50).
     */
    maxResults?: number;
}
export interface GetUsersFromGroupResponseOK extends GetUsersResponse {
}
export declare type GetUsersFromGroupResponseError = undefined;
export interface AddUsersToGroupRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * A name of requested group.
     */
    groupname: string;
    body: {
        /**
         * A name of the added user.
         */
        name: string;
    };
}
export interface AddUsersToGroupResponseOK extends GroupResponse {
}
export declare type AddUsersToGroupResponseError = undefined;
export interface RemoveUsersFromGroupRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * A name of requested group.
     */
    groupname: string;
    /**
     * User to remove from a group
     */
    username: string;
}
export declare type RemoveUsersFromGroupResponseOK = undefined;
export declare type RemoveUsersFromGroupResponseError = undefined;
//# sourceMappingURL=user.d.ts.map