/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Comment, Comments } from '../../definitions/comment';
import { HeadersOption } from '@managed-api/commons-core';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetIssueCommentsRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * the page offset, if not specified then defaults to 0
     */
    startAt?: number;
    /**
     * how many results on the page should be included. Defaults to 50.
     */
    maxResults?: number;
    /**
     * ordering of the results.
     */
    orderBy?: '-created' | 'created' | '+created';
    /**
     * optional flags: renderedBody (provides body rendered in HTML)
     */
    expand?: string[];
}
export interface GetIssueCommentsResponseOK extends Comments {
}
export declare type GetIssueCommentsResponseError = undefined;
export interface AddIssueCommentRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    expand?: string[];
    body: {
        body?: string;
        visibility?: {
            type?: 'group' | 'role';
            value?: string;
        };
    };
}
export interface AddIssueCommentResponseOK extends Comment {
}
export declare type AddIssueCommentResponseError = undefined;
export interface GetIssueCommentRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    id: string;
    /**
     * optional flags: renderedBody (provides body rendered in HTML)
     */
    expand?: string[];
}
export interface GetIssueCommentResponseOK extends Comment {
}
export declare type GetIssueCommentResponseError = undefined;
export interface UpdateIssueCommentRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    id: string;
    /**
     * optional flags: renderedBody (provides body rendered in HTML)
     */
    expand?: string[];
    body: {
        body?: string;
        visibility?: {
            type?: 'group' | 'role';
            value?: string;
        };
    };
}
export interface UpdateIssueCommentResponseOK extends Comment {
}
export declare type UpdateIssueCommentResponseError = undefined;
export interface DeleteIssueCommentRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    id: string;
}
export declare type DeleteIssueCommentResponseOK = undefined;
export declare type DeleteIssueCommentResponseError = undefined;
//# sourceMappingURL=comment.d.ts.map