/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IdProperty, KeyProperty, NameProperty } from '../../definitions/common';
import { IssueLink } from '../../definitions/issue_link';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface CreateIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    body: {
        type?: NameProperty | IdProperty;
        inwardIssue?: KeyProperty | IdProperty;
        outwardIssue?: KeyProperty | IdProperty;
        comment?: {
            body?: string;
            visibility?: {
                type?: 'group' | 'role';
                value?: string;
            };
        };
    };
}
export declare type CreateIssueLinkResponseOK = undefined;
export declare type CreateIssueLinkResponseError = undefined;
export interface GetIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    linkId: string;
}
export interface GetIssueLinkResponseOK extends IssueLink {
}
export declare type GetIssueLinkResponseError = undefined;
export interface DeleteIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    linkId: string;
}
export declare type DeleteIssueLinkResponseOK = undefined;
export declare type DeleteIssueLinkResponseError = undefined;
//# sourceMappingURL=link.d.ts.map