/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IssueLinkRemote } from '../../../definitions/issue_link_remote';
import { RemoteIssueLink, RemoteIssueLinkListItem } from '../../../definitions/remote_issue_link';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface GetRemoteIssueLinksRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * The id of the remote issue link to be returned. If null (not provided) all remote links for the issue are returned.
     */
    globalId?: string;
}
export interface GetRemoteIssueLinksResponseOK extends Array<RemoteIssueLinkListItem> {
}
export declare type GetRemoteIssueLinksResponseError = undefined;
export interface CreateOrUpdateRemoteIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * If a globalId is provided and a remote issue link exists with that globalId, the remote issue link is updated. Otherwise, the remote issue link is created.
     */
    body: RemoteIssueLink;
}
export interface CreateOrUpdateRemoteIssueLinkResponseOK extends IssueLinkRemote {
}
export declare type CreateOrUpdateRemoteIssueLinkResponseError = undefined;
export interface DeleteRemoteIssueLinkByGlobalIdRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * the global id of the remote issue link
     */
    globalId: string;
}
export declare type DeleteRemoteIssueLinkByGlobalIdResponseOK = undefined;
export declare type DeleteRemoteIssueLinkByGlobalIdResponseError = undefined;
export interface GetRemoteIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    linkId: string;
}
export interface GetRemoteIssueLinkResponseOK extends RemoteIssueLinkListItem {
}
export declare type GetRemoteIssueLinkResponseError = undefined;
export interface UpdateRemoteIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    linkId: string;
    body: RemoteIssueLink;
}
export declare type UpdateRemoteIssueLinkResponseOK = undefined;
export declare type UpdateRemoteIssueLinkResponseError = undefined;
export interface DeleteRemoteIssueLinkRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    linkId: string;
}
export declare type DeleteRemoteIssueLinkResponseOK = undefined;
export declare type DeleteRemoteIssueLinkResponseError = undefined;
//# sourceMappingURL=remote.d.ts.map