/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IssueGetCreateMetadata, IssueGetEditMetadata } from '../../definitions/issue_metadata';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetEditIssueMetadataRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
}
export interface GetEditIssueMetadataResponseOK extends IssueGetEditMetadata {
}
export declare type GetEditIssueMetadataResponseError = undefined;
export interface GetCreateIssueMetadataRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * combined with the projectKeys param, lists the projects with which to filter the results. If absent, all projects are returned. This parameter can be specified multiple times, and/or be a comma-separated list. Specifiying a project that does not exist (or that you cannot create issues in) is not an error, but it will not be in the results.
     */
    projectIds?: (string | number)[];
    /**
     * combined with the projectIds param, lists the projects with which to filter the results. If null, all projects are returned. This parameter can be specified multiple times, and/or be a comma-separated list. Specifiying a project that does not exist (or that you cannot create issues in) is not an error, but it will not be in the results.
     */
    projectKeys?: string[];
    /**
     * combined with issuetypeNames, lists the issue types with which to filter the results. If null, all issue types are returned. This parameter can be specified multiple times, and/or be a comma-separated list. Specifiying an issue type that does not exist is not an error.
     */
    issuetypeIds?: (string | number)[];
    /**
     * combined with issuetypeIds, lists the issue types with which to filter the results. If null, all issue types are returned. This parameter can be specified multiple times, but is NOT interpreted as a comma-separated list. Specifiying an issue type that does not exist is not an error.
     */
    issuetypeNames?: string;
    expand?: string;
}
export interface GetCreateIssueMetadataResponseOK extends IssueGetCreateMetadata {
}
export declare type GetCreateIssueMetadataResponseError = undefined;
//# sourceMappingURL=metadata.d.ts.map