/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { PriorityScheme, PrioritySchemeList } from '../../../definitions/priority_scheme';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface CreateIssuePrioritySchemeRequest extends HeadersOption, ErrorStrategyOption {
    body: PriorityScheme;
}
export interface CreateIssuePrioritySchemeResponseOK extends PriorityScheme {
}
export declare type CreateIssuePrioritySchemeResponseError = undefined;
export interface GetIssuePrioritySchemesRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The page offset, if not specified then defaults to 0.
     */
    startAt?: number;
    /**
     * How many results on the page should be included. Defaults to 100, maximum is 1000.
     */
    maxResults?: number;
    /**
     * All project keys associated with the priority scheme will only be returned if additional query parameter is provided expand=schemes.projectKeys.
     */
    expand?: string;
}
export interface GetIssuePrioritySchemesResponseOK extends PrioritySchemeList {
}
export declare type GetIssuePrioritySchemesResponseError = undefined;
export interface DeleteIssuePrioritySchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
}
export declare type DeleteIssuePrioritySchemeResponseOK = undefined;
export declare type DeleteIssuePrioritySchemeResponseError = undefined;
export interface UpdateIssuePrioritySchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    body: PriorityScheme;
    /**
     * All project keys associated with the priority scheme will only be returned if additional query parameter is provided expand=projectKeys.
     */
    expand?: string;
}
export interface UpdateIssuePrioritySchemeResponseOK extends PriorityScheme {
}
export declare type UpdateIssuePrioritySchemeResponseError = undefined;
export interface GetIssuePrioritySchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    /**
     * All project keys associated with the priority scheme will only be returned if additional query parameter is provided expand=projectKeys.
     */
    expand?: string;
}
export interface GetIssuePrioritySchemeResponseOK extends PriorityScheme {
}
export declare type GetIssuePrioritySchemeResponseError = undefined;
//# sourceMappingURL=scheme.d.ts.map