/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { EntityProperty } from '../../definitions/common';
import { PropertyKeys } from '../../definitions/property_key';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetIssuePropertyKeysRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
}
export interface GetIssuePropertyKeysResponseOK extends PropertyKeys {
}
export declare type GetIssuePropertyKeysResponseError = undefined;
export interface DeleteIssuePropertyRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    propertyKey: string | number;
}
export declare type DeleteIssuePropertyResponseOK = undefined;
export declare type DeleteIssuePropertyResponseError = undefined;
export interface SetIssuePropertyRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    propertyKey: string | number;
    body: Record<string, any>;
}
export declare type SetIssuePropertyResponseOK = undefined;
export declare type SetIssuePropertyResponseError = undefined;
export interface GetIssuePropertyRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    propertyKey: string | number;
}
export interface GetIssuePropertyResponseOK extends EntityProperty {
}
export declare type GetIssuePropertyResponseError = undefined;
//# sourceMappingURL=property.d.ts.map