/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { EntityProperty, IdProperty } from '../../definitions/common';
import { HistoryMetadata } from '../../definitions/history_metadata';
import { FieldsEditIssue } from '../../definitions/issue';
import { Transitions } from '../../definitions/transition';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetIssueTransitionsRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    transitionId?: string;
    expand?: string[];
}
export interface GetIssueTransitionsResponseOK extends Transitions {
}
export declare type GetIssueTransitionsResponseError = undefined;
export interface PerformIssueTransitionRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    body: {
        transition?: IdProperty;
        fields?: FieldsEditIssue;
        update?: Record<string, {
            set?: any;
            edit?: any;
            add?: any;
            remove?: any;
        }[]>;
        historyMetadata?: HistoryMetadata;
        properties?: EntityProperty[];
    };
}
export declare type PerformIssueTransitionResponseOK = undefined;
export declare type PerformIssueTransitionResponseError = undefined;
//# sourceMappingURL=transition.d.ts.map