/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IssueType } from '../../definitions/issue_type';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetIssueTypesRequest extends HeadersOption, ErrorStrategyOption {
}
export interface GetIssueTypesResponseOK extends Array<IssueType> {
}
export declare type GetIssueTypesResponseError = undefined;
export interface CreateIssueTypeRequest extends HeadersOption, ErrorStrategyOption {
    body: {
        name: string;
        description?: string;
        type?: 'subask' | 'standard';
    };
}
export interface CreateIssueTypeResponseOK extends IssueType {
}
export declare type CreateIssueTypeResponseError = undefined;
export interface GetIssueTypeRequest extends HeadersOption, ErrorStrategyOption {
    id: string;
}
export interface GetIssueTypeResponseOK extends IssueType {
}
export declare type GetIssueTypeResponseError = undefined;
export interface DeleteIssueTypeRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    alternativeIssueTypeId?: string;
}
export declare type DeleteIssueTypeResponseOK = undefined;
export declare type DeleteIssueTypeResponseError = undefined;
export interface UpdateIssueTypeRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: {
        name?: string;
        description?: string;
        avatarId?: number;
    };
}
export interface UpdateIssueTypeResponseOK extends IssueType {
}
export declare type UpdateIssueTypeResponseError = undefined;
export interface GetAlternativeIssueTypesRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export interface GetAlternativeIssueTypesResponseOK extends Array<IssueType> {
}
export declare type GetAlternativeIssueTypesResponseError = undefined;
//# sourceMappingURL=type.d.ts.map