/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IssueTypeScheme, IssueTypeSchemeCreateUpdate, IssueTypeSchemeList } from '../../../definitions/issue_type_scheme';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface CreateIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    body: IssueTypeSchemeCreateUpdate;
}
export interface CreateIssueTypeSchemeResponseOK extends IssueTypeScheme {
}
export declare type CreateIssueTypeSchemeResponseError = undefined;
export interface GetIssueTypeSchemesRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * All issue types associated with the scheme will only be returned if an additional query parameter is provided: expand=schemes.issueTypes.
     * Similarly, the default issue type associated with the scheme (if one exists) will only be returned if additional an query parameter is provided: expand=schemes.defaultIssueType.
     * Note that both query parameters can be used together: expand=schemes.issueTypes,schemes.defaultIssueType.
     */
    expand?: string;
}
export interface GetIssueTypeSchemesResponseOK extends IssueTypeSchemeList {
}
export declare type GetIssueTypeSchemesResponseError = undefined;
export interface GetIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    /**
    * All issue types associated with the scheme will only be returned if an additional query parameter is provided: expand=schemes.issueTypes.
    * Similarly, the default issue type associated with the scheme (if one exists) will only be returned if additional an query parameter is provided: expand=schemes.defaultIssueType.
    * Note that both query parameters can be used together: expand=schemes.issueTypes,schemes.defaultIssueType.
    */
    expand?: string;
    schemeId: string | number;
}
export interface GetIssueTypeSchemeResponseOK extends IssueTypeScheme {
}
export declare type GetIssueTypeSchemeResponseError = undefined;
export interface UpdateIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    body: IssueTypeSchemeCreateUpdate;
}
export interface UpdateIssueTypeSchemeResponseOK extends IssueTypeScheme {
}
export declare type UpdateIssueTypeSchemeResponseError = undefined;
export interface DeleteIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
}
export declare type DeleteIssueTypeSchemeResponseOK = undefined;
export declare type DeleteIssueTypeSchemeResponseError = undefined;
//# sourceMappingURL=scheme.d.ts.map