/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { AssociateProjects, Project } from '../../../../definitions/project';
import { ErrorStrategyOption } from '../../../../errorStrategy';
export interface AddProjectAssociationsToIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    body: AssociateProjects;
}
export declare type AddProjectAssociationsToIssueTypeSchemeResponseOK = undefined;
export declare type AddProjectAssociationsToIssueTypeSchemeResponseError = undefined;
export interface GetProjectAssociationsForIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    /**
     * The parameters to expand on the returned projects; defaults to none.
     */
    expand?: string;
}
export interface GetProjectAssociationsForIssueTypeSchemeResponseOK extends Array<Project> {
}
export declare type GetProjectAssociationsForIssueTypeSchemeResponseError = undefined;
export interface SetProjectAssociationsForIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    body: AssociateProjects;
}
export declare type SetProjectAssociationsForIssueTypeSchemeResponseOK = undefined;
export declare type SetProjectAssociationsForIssueTypeSchemeResponseError = undefined;
export interface RemoveProjectAssociationsForIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
}
export declare type RemoveProjectAssociationsForIssueTypeSchemeResponseOK = undefined;
export declare type RemoveProjectAssociationsForIssueTypeSchemeResponseError = undefined;
export interface RemoveProjectAssociationForIssueTypeSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
    projIdOrKey: string | number;
}
export declare type RemoveProjectAssociationForIssueTypeSchemeResponseOK = undefined;
export declare type RemoveProjectAssociationForIssueTypeSchemeResponseError = undefined;
//# sourceMappingURL=project.d.ts.map