/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { IssueWatchers } from '../../definitions/issue_watcher';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetIssueWatchersRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
}
export interface GetIssueWatchersResponseOK extends IssueWatchers {
}
export declare type GetIssueWatchersResponseError = undefined;
export interface AddIssueWatcherRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * User's name
     */
    body: string;
}
export declare type AddIssueWatcherResponseOK = undefined;
export declare type AddIssueWatcherResponseError = undefined;
export interface RemoveIssueWatcherRequest extends HeadersOption, ErrorStrategyOption {
    issueIdOrKey: string | number;
    /**
     * a String containing the name of the user to remove from the watcher list. Must not be null.
     */
    username: string;
}
export declare type RemoveIssueWatcherResponseOK = undefined;
export declare type RemoveIssueWatcherResponseError = undefined;
//# sourceMappingURL=watcher.d.ts.map