/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { PermissionScheme, PermissionSchemes } from '../../definitions/permission_scheme';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetPermissionSchemesRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * If you want to include permissions of all the schemes, then specify the permissions expand parameter.
     * Permissions will be included also if you specify any other expand parameter.
     */
    expand?: string;
}
export interface GetPermissionSchemesResponseOK extends PermissionSchemes {
}
export declare type GetPermissionSchemesResponseError = undefined;
export interface CreatePermissionSchemeRequest extends HeadersOption, ErrorStrategyOption {
    expand?: string;
    body: PermissionScheme;
}
export interface CreatePermissionSchemeResponseOK extends PermissionScheme {
}
export declare type CreatePermissionSchemeResponseError = undefined;
export interface GetPermissionSchemeRequest extends HeadersOption, ErrorStrategyOption {
    expand?: string;
    schemeId: string | number;
}
export interface GetPermissionSchemeResponseOK extends PermissionScheme {
}
export declare type GetPermissionSchemeResponseError = undefined;
export interface DeletePermissionSchemeRequest extends HeadersOption, ErrorStrategyOption {
    schemeId: string | number;
}
export declare type DeletePermissionSchemeResponseOK = undefined;
export declare type DeletePermissionSchemeResponseError = undefined;
export interface UpdatePermissionSchemeRequest extends HeadersOption, ErrorStrategyOption {
    expand?: string;
    schemeId: string | number;
    body: PermissionScheme;
}
export interface UpdatePermissionSchemeResponseOK extends PermissionScheme {
}
export declare type UpdatePermissionSchemeResponseError = undefined;
//# sourceMappingURL=scheme.d.ts.map