/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { Component } from '../../definitions/component';
import { ComponentIssues } from '../../definitions/component_issues';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface CreateProjectComponentRequest extends HeadersOption, ErrorStrategyOption {
    body: {
        name: string;
        description?: string;
        leadUserName?: string;
        assigneeType?: 'PROJECT_DEFAULT' | 'COMPONENT_LEAD' | 'PROJECT_LEAD' | 'UNASSIGNED';
        project: string;
    };
}
export interface CreateProjectComponentResponseOK extends Component {
}
export declare type CreateProjectComponentResponseError = undefined;
export interface GetProjectComponentRequest extends HeadersOption, ErrorStrategyOption {
    id: string;
}
export interface GetProjectComponentResponseOK extends Component {
}
export declare type GetProjectComponentResponseError = undefined;
export interface UpdateProjectComponentRequest extends HeadersOption, ErrorStrategyOption {
    id: string;
    body: {
        name?: string;
        description?: string;
        leadUserName?: string;
        assigneeType?: 'PROJECT_DEFAULT' | 'COMPONENT_LEAD' | 'PROJECT_LEAD' | 'UNASSIGNED';
        project?: string;
    };
}
export interface UpdateProjectComponentResponseOK extends Component {
}
export declare type UpdateProjectComponentResponseError = undefined;
export interface DeleteProjectComponentRequest extends HeadersOption, ErrorStrategyOption {
    id: string;
    /**
     * The new component applied to issues whose 'id' component will be deleted. If this value is null, then the 'id' component is simply removed from the related isues.
     */
    moveIssuesTo?: string;
}
export declare type DeleteProjectComponentResponseOK = undefined;
export declare type DeleteProjectComponentResponseError = undefined;
export interface GetProjectComponentRelatedIssueCountRequest extends HeadersOption, ErrorStrategyOption {
    id: string;
}
export interface GetProjectComponentRelatedIssueCountResponseOK extends ComponentIssues {
}
export declare type GetProjectComponentRelatedIssueCountResponseError = undefined;
//# sourceMappingURL=component.d.ts.map