/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { ProjectRole } from '../../../definitions/project_role';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface SetProjectRoleActorsRequest extends HeadersOption, ErrorStrategyOption {
    projectIdOrKey: string;
    id: string | number;
    body: {
        categorisedActors: {
            'atlassian-user-role-actor'?: string[];
            'atlassian-group-role-actor'?: string[];
        };
    };
}
export interface SetProjectRoleActorsResponseOK extends ProjectRole {
}
export declare type SetProjectRoleActorsResponseError = undefined;
export interface AddProjectRoleActorUsersRequest extends HeadersOption, ErrorStrategyOption {
    projectIdOrKey: string;
    id: string | number;
    body: {
        user?: string[];
        group?: string[];
    };
}
export interface AddProjectRoleActorUsersResponseOK extends ProjectRole {
}
export declare type AddProjectRoleActorUsersResponseError = undefined;
export interface DeleteProjectRoleActorRequest extends HeadersOption, ErrorStrategyOption {
    projectIdOrKey: string;
    id: string | number;
    /**
     * the username to remove from the project role
     */
    user?: string;
    /**
     * the groupname to remove from the project role
     */
    group?: string;
}
export declare type DeleteProjectRoleActorResponseOK = undefined;
export declare type DeleteProjectRoleActorResponseError = undefined;
//# sourceMappingURL=actor.d.ts.map