/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { RemoteLink, RemoteLinkList } from '../../../definitions/remote_link';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface GetRemoteVersionLinksByIdRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
}
export interface GetRemoteVersionLinksByIdResponseOK extends RemoteLinkList {
}
export declare type GetRemoteVersionLinksByIdResponseError = undefined;
export interface CreateOrUpdateRemoteVersionLinkByIdRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
    body: {
        globalId?: string;
        [x: string]: any;
    };
}
export declare type CreateOrUpdateRemoteVersionLinkByIdResponseOK = undefined;
export declare type CreateOrUpdateRemoteVersionLinkByIdResponseError = undefined;
export interface DeleteRemoteVersionLinksByIdRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
}
export declare type DeleteRemoteVersionLinksByIdResponseOK = undefined;
export declare type DeleteRemoteVersionLinksByIdResponseError = undefined;
export interface GetRemoteVersionLinkRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
    globalId: string;
}
export interface GetRemoteVersionLinkResponseOK extends RemoteLink {
}
export declare type GetRemoteVersionLinkResponseError = undefined;
export interface CreateOrUpdateRemoteVersionLinkRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
    globalId: string;
    body: {
        globalId?: string;
        [x: string]: any;
    };
}
export interface CreateOrUpdateRemoteVersionLinkResponseOK extends RemoteLink {
}
export declare type CreateOrUpdateRemoteVersionLinkResponseError = undefined;
export interface DeleteRemoteVersionLinkRequest extends HeadersOption, ErrorStrategyOption {
    versionId: string | number;
    globalId: string;
}
export declare type DeleteRemoteVersionLinkResponseOK = undefined;
export declare type DeleteRemoteVersionLinkResponseError = undefined;
export interface GetRemoteVersionLinksRequest extends HeadersOption, ErrorStrategyOption {
    globalId: string;
}
export interface GetRemoteVersionLinksResponseOK extends RemoteLinkList {
}
export declare type GetRemoteVersionLinksResponseError = undefined;
//# sourceMappingURL=remote.d.ts.map