/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { CreateUpdateProjectRole, ProjectRole, UpdateFullyProjectRole } from '../../definitions/project_role';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetGlobalProjectRolesRequest extends HeadersOption, ErrorStrategyOption {
}
export interface GetGlobalProjectRolesResponseOK extends Array<ProjectRole> {
}
export declare type GetGlobalProjectRolesResponseError = undefined;
export interface CreateGlobalProjectRoleRequest extends HeadersOption, ErrorStrategyOption {
    body: CreateUpdateProjectRole;
}
export interface CreateGlobalProjectRoleResponseOK extends ProjectRole {
}
export declare type CreateGlobalProjectRoleResponseError = undefined;
export interface GetGlobalProjectRoleRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export interface GetGlobalProjectRoleResponseOK extends ProjectRole {
}
export declare type GetGlobalProjectRoleResponseError = undefined;
export interface UpdateGlobalProjectRolePartiallyRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: CreateUpdateProjectRole;
}
export interface UpdateGlobalProjectRolePartiallyResponseOK extends ProjectRole {
}
export declare type UpdateGlobalProjectRolePartiallyResponseError = undefined;
export interface UpdateGlobalProjectRoleFullyRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: UpdateFullyProjectRole;
}
export interface UpdateGlobalProjectRoleFullyResponseOK extends ProjectRole {
}
export declare type UpdateGlobalProjectRoleFullyResponseError = undefined;
export interface DeleteGlobalProjectRoleRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    /**
     * If given, removes a role even if it is used in scheme by replacing the role with the given one.
     */
    swap?: string;
}
export declare type DeleteGlobalProjectRoleResponseOK = undefined;
export declare type DeleteGlobalProjectRoleResponseError = undefined;
//# sourceMappingURL=project.d.ts.map