/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { ActorInput, ProjectRole } from '../../../definitions/project_role';
import { ErrorStrategyOption } from '../../../errorStrategy';
export interface GetGlobalProjectRoleActorsRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export interface GetGlobalProjectRoleActorsResponseOK extends ProjectRole {
}
export declare type GetGlobalProjectRoleActorsResponseError = undefined;
export interface AddGlobalProjectRoleActorsRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: ActorInput;
}
export interface AddGlobalProjectRoleActorsResponseOK extends ProjectRole {
}
export declare type AddGlobalProjectRoleActorsResponseError = undefined;
export interface DeleteGlobalProjectRoleActorsRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    /**
     * If given, removes an actor from given role.
     */
    user?: string;
    /**
     * If given, removes an actor from given role.
     */
    group?: string;
}
export interface DeleteGlobalProjectRoleActorsResponseOK extends ProjectRole {
}
export declare type DeleteGlobalProjectRoleActorsResponseError = undefined;
//# sourceMappingURL=actor.d.ts.map