/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { Screen, ScreenableField, ScreensWithPagination } from '../definitions/screen';
import { ErrorStrategyOption } from '../errorStrategy';
export interface GetScreenFieldsToAddRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
}
export interface GetScreenFieldsToAddResponseOK extends Array<ScreenableField> {
}
export declare type GetScreenFieldsToAddResponseError = undefined;
export interface GetScreensRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Offset from which the response starts.
     */
    startAt?: number;
    /**
     * Amount of field screens to return.
     */
    maxResults?: number;
    expand?: string;
    search?: string;
}
export declare type GetScreensResponseOK = Array<Screen> | ScreensWithPagination;
export declare type GetScreensResponseError = undefined;
//# sourceMappingURL=screen.d.ts.map