/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { ScreenableField, ScreenableTab } from '../../definitions/screen';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface GetScreenFieldsRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    /**
     * The key of the project; this parameter is optional.
     */
    projectKey?: string;
}
export interface GetScreenFieldsResponseOK extends Array<ScreenableTab> {
}
export declare type GetScreenFieldsResponseError = undefined;
export interface AddScreenFieldRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    body: {
        fieldId: string | number;
    };
}
export interface AddScreenFieldResponseOK extends ScreenableField {
}
export declare type AddScreenFieldResponseError = undefined;
export interface RemoveScreenFieldRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    id: string | number;
}
export declare type RemoveScreenFieldResponseOK = undefined;
export declare type RemoveScreenFieldResponseError = undefined;
export interface MoveScreenFieldRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    id: string | number;
    body: {
        after?: string;
        position?: 'Earlier' | 'Later' | 'First' | 'Last';
    };
}
export declare type MoveScreenFieldResponseOK = undefined;
export declare type MoveScreenFieldResponseError = undefined;
export interface AddFieldToDefaultScreenRequest extends HeadersOption, ErrorStrategyOption {
    fieldId: string | number;
}
export declare type AddFieldToDefaultScreenResponseOK = undefined;
export declare type AddFieldToDefaultScreenResponseError = undefined;
//# sourceMappingURL=field.d.ts.map