/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { ScreenableTab } from '../../definitions/screen';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface AddScreenTabRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    body: ScreenableTab;
}
export interface AddScreenTabResponseOK extends ScreenableTab {
}
export declare type AddScreenTabResponseError = undefined;
export interface GetScreenTabsRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    /**
     * The key of the project; this parameter is optional.
     */
    projectKey?: string;
}
export interface GetScreenTabsResponseOK extends Array<ScreenableTab> {
}
export declare type GetScreenTabsResponseError = undefined;
export interface RenameScreenTabRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    body: ScreenableTab;
}
export interface RenameScreenTabResponseOK extends ScreenableTab {
}
export declare type RenameScreenTabResponseError = undefined;
export interface DeleteScreenTabRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
}
export declare type DeleteScreenTabResponseOK = undefined;
export declare type DeleteScreenTabResponseError = undefined;
export interface MoveScreenTabRequest extends HeadersOption, ErrorStrategyOption {
    screenId: string | number;
    tabId: string | number;
    pos: string | number;
}
export declare type MoveScreenTabResponseOK = undefined;
export declare type MoveScreenTabResponseError = undefined;
//# sourceMappingURL=tab.d.ts.map