/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { UserFull } from '../definitions/user';
import { ErrorStrategyOption } from '../errorStrategy';
export interface GetUserRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * the username
     */
    username?: string;
    /**
     * user key
     */
    key?: string;
}
export interface GetUserResponseOK extends UserFull {
}
export declare type GetUserResponseError = undefined;
export interface UpdateUserRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * the username
     */
    username?: string;
    /**
     * user key
     */
    key?: string;
    body: {
        name?: string;
        emailAddress?: string;
        displayName?: string;
        active?: boolean;
    };
}
export interface UpdateUserResponseOK extends UserFull {
}
export declare type UpdateUserResponseError = undefined;
export interface CreateUserRequest extends HeadersOption, ErrorStrategyOption {
    body: {
        name: string;
        emailAddress: string;
        displayName: string;
        password?: string;
        notification?: string;
        applicationKeys?: string[];
    };
}
export interface CreateUserResponseOK extends UserFull {
}
export declare type CreateUserResponseError = undefined;
export interface RemoveUserRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * the username
     */
    username?: string;
    /**
     * user key
     */
    key?: string;
}
export declare type RemoveUserResponseOK = undefined;
export declare type RemoveUserResponseError = undefined;
export interface AddUserToApplicationRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * username
     */
    username: string;
    /**
     * application key
     */
    applicationKey: string;
}
export declare type AddUserToApplicationResponseOK = undefined;
export declare type AddUserToApplicationResponseError = undefined;
export interface RemoveUserFromApplicationRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * username
     */
    username: string;
    /**
     * application key
     */
    applicationKey: string;
}
export declare type RemoveUserFromApplicationResponseOK = undefined;
export declare type RemoveUserFromApplicationResponseError = undefined;
export interface ChangeUserPasswordRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * the username
     */
    username?: string;
    /**
     * user key
     */
    key?: string;
    body: {
        password: string;
    };
}
export declare type ChangeUserPasswordResponseOK = undefined;
export declare type ChangeUserPasswordResponseError = undefined;
//# sourceMappingURL=user.d.ts.map