/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { HeadersOption } from '@managed-api/commons-core';
import { WorkflowScheme } from '../../definitions/workflow';
import { ErrorStrategyOption } from '../../errorStrategy';
export interface CreateWorkflowSchemeRequest extends HeadersOption, ErrorStrategyOption {
    body: WorkflowScheme;
}
export interface CreateWorkflowSchemeResponseOK extends WorkflowScheme {
}
export declare type CreateWorkflowSchemeResponseError = undefined;
export interface GetWorkflowSchemeRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    /**
     * When true indicates that a scheme's draft, if it exists, should be queried instead of the scheme itself.
     */
    returnDraftIfExists?: boolean;
}
export interface GetWorkflowSchemeResponseOK extends WorkflowScheme {
}
export declare type GetWorkflowSchemeResponseError = undefined;
export interface DeleteWorkflowSchemeRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
}
export declare type DeleteWorkflowSchemeResponseOK = undefined;
export declare type DeleteWorkflowSchemeResponseError = undefined;
export interface UpdateWorkflowSchemeRequest extends HeadersOption, ErrorStrategyOption {
    id: string | number;
    body: WorkflowScheme;
}
export interface UpdateWorkflowSchemeResponseOK extends WorkflowScheme {
}
export declare type UpdateWorkflowSchemeResponseError = undefined;
//# sourceMappingURL=scheme.d.ts.map